use strict;
use warnings;

sub convert
{
  my ( $decimal, $number_system, $result ) = @_;

  if( $decimal >= $number_system )
  {
    my $remainder = $decimal % $number_system;
    push( @$result, $remainder );

    convert( ( $decimal - $remainder ) / $number_system, $number_system, $result );
  }
  else
  {
    push( @$result, $decimal );
  }
}

sub get_translate_from_table
{
  my ( $src_lang ) = @_;
  my @src_lang     = split( "", $src_lang );

  my $result       = {};
  my $counter      = 0;
  for my $char ( @src_lang )
  {
    $result->{ $char } = $counter++;
  }

  return $result;
}
sub translate_from
{
  my ( $alien_number, $src_lang ) = @_;

  my $translate_table = get_translate_from_table( $src_lang );
  my $src_len         = length( $src_lang );

  my $result = 0;

  my @alien_number = split( "", $alien_number );
  my $counter      = length( $alien_number ) - 1;
  for my $char ( @alien_number )
  {
    $result += $translate_table->{ $char } * ( $src_len ** ( $counter-- ) );
  }

  return $result;
}

sub get_translate_to_table
{
  my ( $dst_lang ) = @_;
  my @dst_lang     = split( "", $dst_lang );

  my $result       = {};
  my $counter      = 0;
  for my $char ( @dst_lang )
  {
    $result->{ $counter++ } = $char;
  }

  return $result;
}
sub translate_to
{
  my ( $convert_result_arr, $dst_lang ) = @_;

  my $translate_table = get_translate_to_table( $dst_lang );

  my $result = "";
  while( defined ( my $item = pop( @$convert_result_arr ) ) )
  {
    $result .= $translate_table->{ $item };
  }
  return $result;
}

open( INPUT, '<', 'sample_input' );
  my $total_count = <INPUT>;
  my $case_count  = 1;

  while( $case_count <= $total_count )
  {
    my ( $alien_number, $src_lang, $dst_lang ) = split( ' ', <INPUT> );

    my $decimal    = translate_from( $alien_number, $src_lang );
    my $result_arr = [];
    convert( $decimal, length( $dst_lang ), $result_arr );
    printf( "Case #%d: %s\n", $case_count++, translate_to( $result_arr, $dst_lang ) );
  }
close( INPUT );
